;*****************************************************
;*                 *       
;*****************************************************
;* :              ..                     *
;*  :  AVR Studio v4.13               *
;* :         ATtiny13(L)                    *
;*  :                                *
;*  PB0 -   K2   F   (5) *
;*  PB1 -       DI (6) *
;*  PB2 -     SC       (7) *
;*  PB5 -                (1) *
;*  ADC2 -            (3) *
;*  ADC3 -            (2) *
;*  VCC -        (8) *
;*  GND -         (4) *
;*  :                                *
;*      BODLEVEL0 = 0   SPIEN  = 0   CKSEL0 = 1      *
;*      BODLEVEL1 = 0   EESAVE = 1   CKSEL1 = 0      *
;*      DWEN      = 1   WDTON  = 1   SUT0   = 0      *
;*      SELFPRGEN = 1   CKDIV8 = 1   SUT1   = 1      *
;*      RSTDISBL  = 0                                *
;*  FLASH:              1020                     *  
;*  SRAM:                 21                     *
;*  EEPROM:                3                     *               
;*                                 kotov_ig@mail.ru  *
;*****************************************************

	       .nolist
          .include "tn13def.inc"
           .list

        .equ   DI    =  PB1
        .equ   SC    =  PB2
		.equ   POV   =  PB5
		.equ   ERROR =  5

;                 flag
; 0 -   /   (1/0)  
; 1 -     /    (1/0)

;                 picter
; 0b00000000 -       
; 0b00000001 -   uhi 
; 0b00000010 -   ulo
; 0b00000011 -   dlt
; 0b00000101 -    
; 0b00000110 -    
; 0b00000111 -     

;                 button
; 0b00000000 -      
; 0b00000001 -    MD(SB3)       
; 0b00000010 -    DN(SB2) 
; 0b00000011 -    UP(SB1)

	   .def  zero     = R0   ;,     
	   .def  dt_max   = R1   ;   
	   .def  ul_min   = R2   ;    160
	   .def  ul_max   = R3   ;    218
	   .def  uh_min   = R4   ;    222
	   .def  uh_max   = R5   ;    255
       .def  uh       = R6   ;  
	   .def  ul       = R7   ;  
	   .def  dt       = R8   ;  
	   .def  data     = R9   ; 
	   .def  cycle	  = R10  ; 
	   .def  indbuf   = R11  ; 
	   .def  delay    = R12  ;  
	   .def  button   = R13  ;  
	   .def  btn      = R14  ;   
	   .def  lstbtn   = R15  ;    
       .def  tmp      = R16  ;   
	   .def  picter   = R17  ; 
       .def  wait     = R18  ;      
	   .def  u        = R19  ;   
	   .def  cnt      = R20  ; 
	   .def  presc    = R21  ;,   1
	   .def  task     = R22  ; 
	   .def  flag     = R24  ;  
	   .def  alarm    = R25  ;    

; XH:XL -     
; YH:YL -       
; ZH:ZL -     

           .dseg 
		  .org SRAM_START
       ind_u  :  .byte  3  ;  
  	   ind_uhi:  .byte  3  ;  uhi
       ind_ulo:  .byte  3  ;  ulo
       ind_dlt:  .byte  3  ;  dlt
       ind_uh :  .byte  3  ;   
       ind_ul :  .byte  3  ;    
       ind_dt :  .byte  3  ;   
  
		   .eseg 
		  .org 0
       _uh:  .db   250     ;   255
       _ul:  .db   170     ;   170
       _dt:  .db   5       ;    5
 		  
		   .cseg
          .org  0
        rjmp  initial 
		rjmp  0
		rjmp  0
		rjmp  0
		rjmp  0
		rjmp  0
		rjmp  service_T0COMPA
        rjmp  service_T0COMPB
		rjmp  0
	    rjmp  0

;******************************************************
;*                            *
;******************************************************  
     
btn_polling:
        cli
        ldi   tmp,(1<<ADLAR)|(1<<MUX1)
        rcall do_adc
		push  data
        in    data,ADCL
        in    tmp,ADCH
		sbrc  data,7
	  	inc   tmp
        push  tmp
	  	ldi   tmp,255
	 	mov   data,tmp
		pop   tmp		
        sub   data,tmp
        ldi   tmp,255
	    clr   btn      
  bp2:  sub   tmp,data 
	    inc   btn      
	    brcc  bp2      
	    add   tmp,data 
	    lsl   tmp      
	    sub   tmp,data 
        brcc  bp3
	    dec   btn
  bp3:  mov   tmp,btn
        cpi   tmp,4    
        brcs  bp4      
        clr   btn     
  bp4:  pop   data
        mov   tmp,btn
  bp6:  tst   btn
		brne  pb7
        clr   XH
        clr   XL
		clr   button	
        reti
  pb7:  adiw  XH:XL,2
		cpse  XL,zero
        rjmp  pb9
        cpi   XH,1
        brne  pb8
        mov   button,btn
		rjmp  pb9
  pb8:  cpi   XH,30
        brne  pb9
        ldi   XH,27
        mov   button,btn
  pb9:  mov   lstbtn,btn
        reti

;******************************************************
;*                     *
;****************************************************** 

volt_measur:
        cli
        ldi   tmp,(1<<ADLAR)|(1<<MUX1)|(1<<MUX0)
        rcall do_adc
		in    tmp,ADCL
		in    u,ADCH
		sbrc  tmp,7
		inc   u
		reti

;******************************************************
;*            *
;******************************************************

volt_comper:
        cp    u,ul
		brcc  vc1
		inc   alarm
		rjmp  vc3 
  vc1:  cp    uh,u
		brcc  vc2
		inc   alarm
        rjmp  vc3
  vc2:  clr   alarm
        sbrs  flag,1
		ret
		mov   delay,dt
		cbr   flag,1<<1
		ret
  vc3:  cpi   alarm,ERROR
        brne  vc4
		clr   alarm
		clr   delay
		sbr   flag,1<<1 
  vc4:	ret

;******************************************************
;*     *
;****************************************************** 

eeprom_write:
        sbic  EECR,EEWE
		rjmp  eeprom_write
	    out   EEAR,tmp
	    out   EEDR,data
		sbi   EECR,EEMWE
		sbi   EECR,EEWE
		ret

;******************************************************
;*                     *
;******************************************************

write_simbol:
        ldi   cnt,8
		rjmp  ws2
  ws1:  lsl   tmp
  ws2:  cbi   PORTB,DI
		sbrc  tmp,7
		sbi   PORTB,DI
		sbi   PORTB,SC
		cbi   PORTB,SC
		dec   cnt
		brne  ws1
		ret

;******************************************************
;*    -     *
;******************************************************
             
bin_dec:
        clr   cnt         
        ldi   tmp,100    
  bd1:	sub   data,tmp     
		inc   cnt          
		brcc  bd1        
		dec   cnt          
		add   data,tmp
		st    Y,cnt
        clr   cnt
        ldi   tmp,10
  bd2:	sub   data,tmp
		inc   cnt
		brcc  bd2
		dec   cnt
		add   data,tmp
        std   Y+1,cnt
		std   Y+2,data
		ret

;******************************************************
;*          *
;******************************************************

blink_dim:
        sbic  PORTB,POV
		ret
     	sbrc  flag,0
		ret
		ldi   tmp,17
		sbrs  flag,1
        rjmp  bl1
		sbrs  cycle,5
		mov   data,tmp
		ret
  bl1:  sbrs  cycle,7
		mov   data,tmp
		ret


;******************************************************
;*            *
;****************************************************** 

get_simbol:
	    rcall blink_dim
		add   ZL,data
        adc   ZH,zero
		lpm   tmp,Z
		ret

;******************************************************
;*                     *
;****************************************************** 

do_adc:
	    out   ADMUX,tmp
		push  XH
		push  XL
	    clr   XH
		ldi   XL,118
        sbiw  XH:XL,1
		brne  PC-1
		pop   XL
		pop   XH
        sbi   ADCSRA,ADSC
        sbis  ADCSRA,ADIF
        rjmp  PC-1
		sbi   ADCSRA,ADIF
		ret

;******************************************************
;*        OCR0A       *
;******************************************************

service_T0COMPA:
        push  tmp
		in    tmp,SREG
		push  tmp
		ldi   ZH,high(2*conv_table)
		ldi   ZL,low(2*conv_table)			
	    cpi   task,0
        breq  simbol0
		cpi   task,1
        breq  simbol1
		cpi   task,2
        breq  simbol2
		rjmp  tablcon
simbol0:
        ldd   data,Y+2
        rcall get_simbol
	    cbi   DDRB,0
		sbrc  tmp,5
		sbi   DDRB,0
		cbi   PORTB,0
		sbrc  tmp,5
		sbi   PORTB,0
		cbr   tmp,1<<7
		sbr   tmp,1<<5
		rcall write_simbol
        ldi   task,1
        rjmp  send
simbol1:
        ldd   data,Y+1
		tst   data
		brne  sm2
		ld    tmp,Y
        tst   tmp
		brne  sm2
		ldi   tmp,17
		mov   data,tmp
  sm2:  rcall get_simbol
	    cbi   DDRB,0
		sbrc  tmp,5
		sbi   DDRB,0
		cbi   PORTB,0
		sbrc  tmp,5
		sbi   PORTB,0
		sbr   tmp,1<<7
		cbr   tmp,1<<5
		rcall write_simbol
        ldi   task,2
        rjmp  send
simbol2:   
		ld    data,Y
		tst   data
		brne  sm3
		ldi   tmp,17
		mov   data,tmp
  sm3:  rcall get_simbol
        sbr   tmp,1<<7
		sbr   tmp,1<<5	           
		rcall write_simbol
		cbi   PORTB,0
		sbi   DDRB,0
        ldi   task,3
        rjmp  send
tablcon:
        push  picter
        swap  picter
		lsl   button
		lsl   button
		add   picter,button
        ldi   ZH,high(state_table)
		ldi   ZL,low(state_table)
		add   ZL,picter
		add   ZH,zero
	    clr   button
		pop   picter
		icall 
		cpi   YL,ind_u
        brne  tb1
		tst   indbuf
		brne  tb0
		mov   data,u
		rcall bin_dec
  tb0:  inc   indbuf
        ldi   tmp,40
		cp    indbuf,tmp
		brne  PC+2
		clr   indbuf
		rjmp  tb4
  tb1:	clr   indbuf
        cpi   YL,ind_uh
        brne  tb2
		mov   data,uh
		rcall bin_dec
		rjmp  tb4
  tb2:	cpi   YL,ind_ul
        brne  tb3
		mov   data,ul
		rcall bin_dec
		rjmp  tb4
  tb3:	cpi   YL,ind_dt
        brne  tb4
		mov   data,dt
		rcall bin_dec
  tb4:	cpi   wait,255
		brne  tb5
		clr   wait
		clr   picter
		cbr   flag,1<<0
		ldi   YL,ind_u
        ldi   tmp,_uh
		mov   data,uh
		rcall eeprom_write
		ldi   tmp,_ul
		mov   data,ul
		rcall eeprom_write
		ldi   tmp,_dt
		mov   data,dt
		rcall eeprom_write
  tb5:  ldi   task,0
        rjmp  send
  send: pop   tmp
		out   SREG,tmp
		pop   tmp
		reti
	    
;******************************************************
;*        OCR0B       *
;******************************************************

service_T0COMPB:
        push  tmp
		in    tmp,SREG
		push  tmp
		wdr
		inc   cycle
		inc   presc
		cpi   presc,250    ; 250 * 4 = 1c
		brne  sb1
		clr   presc
		cpse  delay,zero 
		dec   delay
  sb1:  sbrs  flag,0      ;  : POV=0
		rjmp  sb2
		clr   delay
		cbi   PORTB,POV
		rjmp  sb4
  sb2:  sbrs  flag,1      ;    : POV=0
		rjmp  sb3
		cbi   PORTB,POV
		rjmp  sb4
  sb3:	tst   delay
		brne  sb4
        sbi   PORTB,POV
  sb4:  pop   tmp
        out   SREG,tmp
		pop   tmp
		reti	

;******************************************************
;*                                   *
;******************************************************	
			  
initial:
        ldi   tmp,RAMEND
		out   SPL,tmp
        ldi   tmp,1<<PUD
		out   MCUCR,tmp
		clr   zero
		out   PORTB,zero
		ldi   tmp,(1<<POV)|(1<<DI)|(1<<SC)
		out   DDRB,tmp
        ldi   tmp,_uh
		out   EEAR,tmp
	    sbi   EECR,EERE
		in    uh,EEDR
		ldi   tmp,_ul
		out   EEAR,tmp
	    sbi   EECR,EERE
		in    ul,EEDR
	    ldi   tmp,_dt
		out   EEAR,tmp
	    sbi   EECR,EERE
		in    dt,EEDR    
	    clr   cycle	 
		clr   presc
	    clr   indbuf
	    clr   delay           
    	clr   u
		clr   picter
		clr   wait
		clr   flag
		clr   alarm
		clr   task
		clr   button
		clr   lstbtn 
		clr   YH
		ldi   YL,ind_u
		ldi   tmp,255
		mov   dt_max,tmp
		ldi   tmp,150
		mov   ul_min,tmp
		ldi   tmp,218
		mov   ul_max,tmp
		ldi   tmp,222
		mov   uh_min,tmp
		ldi   tmp,255
		mov   uh_max,tmp
		ldi   tmp,10         ; u
        sts   ind_uhi,tmp
        ldi   tmp,11         ; h
        sts   ind_uhi+1,tmp
		ldi   tmp,12         ; i
        sts   ind_uhi+2,tmp
        ldi   tmp,10         ; u
        sts   ind_ulo,tmp
        ldi   tmp,13         ; l
        sts   ind_ulo+1,tmp
		ldi   tmp,14         ; o
        sts   ind_ulo+2,tmp
        ldi   tmp,15         ; d
        sts   ind_dlt,tmp
        ldi   tmp,13         ; l
        sts   ind_dlt+1,tmp
		ldi   tmp,16         ; t
        sts   ind_dlt+2,tmp
		ldi   tmp,1<<WGM01
		out   TCCR0A,tmp
		ldi   tmp,1<<CS02    ;CK/256 = 9600000/256 = 37500  
		out   TCCR0B,tmp
		ldi   tmp,149        ;CTC, T = 4 
        out   OCR0A,tmp
		ldi   tmp,75
        out   OCR0B,tmp
        ldi   tmp,(1<<OCIE0A)|(1<<OCIE0B)
		out   TIMSK0,tmp
		ldi   tmp,(1<<ADEN)|(1<<ADPS2)|(1<<ADPS0) ; CK/32 = 150z
		out   ADCSRA,tmp
	    ldi   tmp,(1<<WDE)    ;16mS
		out   WDTCR,tmp
		wdr
		sei
main:   rcall btn_polling
        rcall volt_measur
        rjmp  main
       
;******************************************************
;*                     *
;******************************************************

state_table:
picter_ind_u_button_xx:
        clr   wait        ;   
		rcall volt_comper ;     
		nop               ;   
		ret               ;    
picter_ind_u_button_md:   ;picter << 0x04 + button << 0x02
   	    sbr   flag,1<<0   ; 28 4- 
    	ldi   picter,1
		ldi   YL,ind_uhi
		ret
picter_ind_u_button_dn:
        clr   wait
		rcall volt_comper
		nop
		ret
picter_ind_u_button_up:
        clr   wait
		rcall volt_comper
		nop
		ret

picter_ind_uhi_button_xx:
        inc   wait
		ldi   picter,1
		ldi   YL,ind_uhi
		ret
picter_ind_uhi_button_md:
        clr   wait
        ldi   picter,4
		ldi   YL,ind_uh
		ret
picter_ind_uhi_button_dn:
		clr   wait
        ldi   picter,3
		ldi   YL,ind_dlt
		ret
picter_ind_uhi_button_up:
        clr   wait
		ldi   picter,2
		ldi   YL,ind_ulo
		ret

picter_ind_ulo_button_xx:
        inc   wait
		ldi   picter,2
		ldi   YL,ind_ulo
		ret
picter_ind_ulo_button_md:
        clr   wait
        ldi   picter,5
		ldi   YL,ind_ul
		ret
picter_ind_ulo_button_dn:
		clr   wait
        ldi   picter,1
		ldi   YL,ind_uhi
		ret
picter_ind_ulo_button_up:
        clr   wait
		ldi   picter,3
		ldi   YL,ind_dlt
		ret

picter_ind_dlt_button_xx:
        inc   wait
		ldi   picter,3
		ldi   YL,ind_dlt
		ret
picter_ind_dlt_button_md:
        clr   wait
        ldi   picter,6
		ldi   YL,ind_dt
		ret
picter_ind_dlt_button_dn:
		clr   wait
        ldi   picter,2
		ldi   YL,ind_ulo
		ret
picter_ind_dlt_button_up:
        clr   wait
		ldi   picter,1
		ldi   YL,ind_uhi
		ret

picter_ind_uh_button_xx:
        inc   wait
		nop
		nop
		ret
picter_ind_uh_button_md:
        clr   wait
        ldi   picter,1
		ldi   YL,ind_uhi
		ret
picter_ind_uh_button_dn:
        clr   wait
		cpse  uh,uh_min
		dec   uh
		ret
picter_ind_uh_button_up:
        clr   wait
		cpse  uh,uh_max
		inc   uh
		ret

picter_ind_ul_button_xx:
        inc   wait
		nop
		nop
		ret
picter_ind_ul_button_md:
        clr   wait
        ldi   picter,2
		ldi   YL,ind_ulo
		ret
picter_ind_ul_button_dn:
        clr   wait
		cpse  ul,ul_min
		dec   ul
		ret
picter_ind_ul_button_up:
        clr   wait
		cpse  ul,ul_max
		inc   ul
		ret
	
picter_ind_dt_button_xx:
        inc   wait
		nop
		nop
		ret
picter_ind_dt_button_md:
        clr   wait
        ldi   picter,3
		ldi   YL,ind_dlt
        ret
picter_ind_dt_button_dn:
        clr   wait
		cpse  dt,zero
		dec   dt
		ret
picter_ind_dt_button_up:
        clr   wait
		cpse  dt,dt_max
		inc   dt
		ret

;******************************************************
;*            *
;******************************************************

conv_table:         
     .db 0b10111111, 0b10000110  ;0,1
	 .db 0b11011011, 0b11001111  ;2,3
     .db 0b11100110, 0b11101101  ;4,5
     .db 0b11111101, 0b10000111  ;6,7
     .db 0b11111111, 0b11101111  ;8,9
	 .db 0b10011100, 0b11110100  ;u,h
	 .db 0b10000100, 0b10111000  ;i,l
	 .db 0b11011100, 0b11011110  ;o,d
	 .db 0b11111000, 0b10000000  ;t,space
